function [] = triangolatore_delaunay(n_elements_per_direction)

% costruzione della mesh

h = 1 / n_elements_per_direction;
xn  =  0:h:1;
yn  =  0:h:1;
[xn,yn] = meshgrid(xn,yn);          % costruisco la griglia di nodi
xn = reshape(xn,prod(size(xn)),1);  % vettore ascisse  dei nodi
yn = reshape(yn,prod(size(yn)),1);  % vettore ordinate dei nodi
n_node = size(xn,1);                % numero dei nodi   
element = delaunay(xn,yn,{'Qt','Qbb','Qc','Qz'}); % conectivity matrix
n_ele = size(element,1);

% orientamento  counter-clockwise dei nodi
% i triangoli di delaunay hanno orientamento dei nodi a caso
% per il codice FEM servono triangoli con nodi orientati in senso antiorario
% le 5 righe seguenti servono per sistemare il problema
% tratto da http://www.mathworks.com/matlabcentral/newsreader/view_thread/23460

c = sum(xn(element).*(yn(element(:,[3 1 2]))-yn(element(:,[2 3 1]))),2)>0;
tc = element(c,2);
element(c,2) = element(c,3);
element(c,3) = tc;
clear c tc 


% selezione dei nodi di Dirichlet
% si impone la condizione di Dirichlet su tutto il bordo del dominio
% dirichlet_flag = 1 per i nodi di Dirichlet
dirichlet_flag = zeros(n_node,1);
for i_node = 1:n_node
  dirichlet_flag(i_node) = xn(i_node)==0 |  xn(i_node)==1 | yn(i_node)==0 |yn(i_node)==1;
end
trisurf(element,xn,yn,zeros(1,n_node))
view (2)
save quadrato_uniforme.mat  xn yn dirichlet_flag element n_node n_ele 